services:
    laravel.test:
        build:
            context: './docker/8.5'
            dockerfile: Dockerfile
            args:
                WWWGROUP: '${WWWGROUP}'
        image: 'sail-8.5/app'
        container_name: star-erp-laravel
        hostname: star-erp-laravel
        extra_hosts:
            - 'host.docker.internal:host-gateway'
        ports:
            # - '${APP_PORT:-8080}:80'  # 由 proxy 處理
            - '${VITE_PORT:-5173}:${VITE_PORT:-5173}'
        environment:
            WWWUSER: '${WWWUSER}'
            LARAVEL_SAIL: 1
            XDEBUG_MODE: '${SAIL_XDEBUG_MODE:-off}'
            XDEBUG_CONFIG: '${SAIL_XDEBUG_CONFIG:-client_host=host.docker.internal}'
            IGNITION_LOCAL_SITES_PATH: '${PWD}'
        volumes:
            - '.:/var/www/html'
        networks:
            - sail
        depends_on:
            - mysql
            - redis
            # - mailpit
    mysql:
        image: 'mysql/mysql-server:8.0'
        container_name: star-erp-mysql
        hostname: star-erp-mysql
        ports:
            - '${FORWARD_DB_PORT:-3306}:3306'
        environment:
            MYSQL_ROOT_PASSWORD: '${DB_PASSWORD}'
            MYSQL_ROOT_HOST: '%'
            MYSQL_DATABASE: '${DB_DATABASE}'
            MYSQL_USER: '${DB_USERNAME}'
            MYSQL_PASSWORD: '${DB_PASSWORD}'
            MYSQL_ALLOW_EMPTY_PASSWORD: 1
            MYSQL_EXTRA_OPTIONS: '${MYSQL_EXTRA_OPTIONS:-}'
        volumes:
            - 'sail-mysql:/var/lib/mysql'
            - './docker/mysql/create-testing-database.sh:/docker-entrypoint-initdb.d/10-create-testing-database.sh'
        networks:
            - sail
        healthcheck:
            test:
                - CMD
                - mysqladmin
                - ping
                - '-p${DB_PASSWORD}'
            retries: 3
            timeout: 5s
    redis:
        image: 'redis:alpine'
        container_name: star-erp-redis
        hostname: star-erp-redis
        # ports:
        #     - '${FORWARD_REDIS_PORT:-6379}:6379'
        volumes:
            - 'sail-redis:/data'
        networks:
            - sail
        healthcheck:
            test:
                - CMD
                - redis-cli
                - ping
            retries: 3
            timeout: 5s
    proxy:
        image: 'nginx:alpine'
        container_name: star-erp-proxy
        ports:
            - '8080:8080'
            - '8081:8081'
        volumes:
            - './nginx/demo-proxy.conf:/etc/nginx/conf.d/default.conf:ro'
        networks:
            - sail
        depends_on:
            - laravel.test
    # mailpit:
    #     image: 'axllent/mailpit:latest'
    #     ports:
    #         - '${FORWARD_MAILPIT_PORT:-1025}:1025'
    #         - '${FORWARD_MAILPIT_DASHBOARD_PORT:-8025}:8025'
    #     networks:
    #         - sail
networks:
    sail:
        driver: bridge
volumes:
    sail-mysql:
        driver: local
    sail-redis:
        driver: local
